--[[
                                             --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--

            King Julian in "Madagascar" put it best when in response to a question from Alex the Lion he asked rhetorically "Who wipes?". Well...



       --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


      #           #   ###########        #######           ####       #         #  ##   ###########        #           #   #   #######      ###########
      #           #   #                  #      ##       ##    ##     ##        #   ##       #             #           #   #   #      ##    #
      #           #   #                  #        #     #        #    # #       #    ##      #             #           #   #   #        #   #
      #     #     #   #                  #         #   #          #   #  ##     #            #             #     #     #   #   #      ##    #
      #     #     #   ###########        #         #   #          #   #    #    #            #             #     #     #   #   #######      ###########
       #   # #   #    #                  #         #   #          #   #     ##  #            #              #   # #   #    #   #            #
       #   # #   #    #                  #        #     #        #    #       # #            #              #   # #   #    #   #            #
        # #   # #     #                  #      ##       ##    ##     #        ##            #               # #   # #     #   #            #
         #     #      ###########        #######           ####       #         #            #                #     #      #   #            ###########


      --<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--<(o):|:(o)>--


                                                             ----o----(||)----o----(||)----o----

                                                                  v5.05 25th September 2016
                                                                  Copyright (C) Chris Birch

                                                             ----o----(||)----o----(||)----o----


        As Taraezor, Chris is the author of several WoW AddOns, all of which are easily found at https://mods.curse.com/members/Taraezor/projects
        and http://www.wowinterface.com/downloads/author-306149.html. Download elsewhere at your own risk!
]]


--[[ ================== ]]--
--[[     Miscellany     ]]-- ===============================================================================================================
--[[ ================== ]]-- 

local addonName, L = ...

local abs = math.abs
local floor = math.floor
local fmod = math.fmod
local format = string.format
local gmatch = string.gmatch
local gsub = string.gsub
local lower = string.lower
local match = string.match
local modf = math.modf
local print = print
local select = select
local sub = string.sub
local tonumber = tonumber
local tostring = tostring

local GetAddOnMetadata = GetAddOnMetadata
local GetFrameRate = GetFrameRate
local GetItemCooldown = GetItemCooldown
local GetSpellCharges = GetSpellCharges
local GetSpellCooldown = GetSpellCooldown
local GetTime = GetTime
local InCinematic = InCinematic
local IsInInstance = IsInInstance
local IsSpellKnown = IsSpellKnown
local PetBattlesIsInBattle = C_PetBattles.IsInBattle
local PlaySoundFile = PlaySoundFile
local UnitAffectingCombat = UnitAffectingCombat
local UnitBuff = UnitBuff
local UnitCanAttack =  UnitCanAttack
local UnitClass = UnitClass
local UnitInVehicle = UnitInVehicle
local UnitIsDeadOrGhost = UnitIsDeadOrGhost
local UnitPVPName = UnitPVPName
local UnitName = UnitName

--------------------------------------------------------------------------------------------------------------------------------------------
-- Globals
-- =======

wdwMod_Rotations		= {}
wdw_Queue			= {}
wdw_playerLevel			= 0
wdw_buffsPlayer			= {}
wdw_mostRecentSpell		= 0
wdw_trainingDummy		= false

wdw_colour_SelectiveYellow	= "\124cFFFFBA00"	-- Used to prefix WDW chat lines. The signature colour of WDW
wdw_colour_MalachiteGreen	= "\124cFF0BDA51"	-- Used as a highlight for lines and chat text and warning messages
wdw_colour_Jasmine		= "\124cFFF8DE7E"	-- Plain text colour. A very pale yellowish white

wdw_GCDtop	= 1.5		-- The time Blizzard makes you wait between hotbar key presses and varies between classes. A Mage
				-- starts with 1.5s and a Windwalker always has 1s. Your class might enjoy lower than 1.5s due to
				-- lots of haste gear. Never below 1s. WDW sets this by itself
wdw_GCD		= 0		-- The remaining time of the Global Cooldown you must wait out. Between zero and wdw_GCDtop

--------------------------------------------------------------------------------------------------------------------------------------------

local function round( num, places )		-- round to nearest integer, ties round away from zero
	local mult = 10 ^ ( places or 0 )
	return modf( num * mult + ( ( num < 0 and -1 ) or 1 ) * 0.5 ) / mult
end

local function printWDW( message )
	DEFAULT_CHAT_FRAME:AddMessage( wdw_colour_SelectiveYellow.. "WeDon'tWipe: ".. wdw_colour_Jasmine.. tostring( message ).. "\124r" )
end

local wdw_PTU_times = 0
local wdw_englishClass, wdw_currentSpec, wdw_hasRotation = "", "", false

local wdw_lowCD, wdw_lowStart, wdw_lowDuration, wdw_spellItemID = 0, 0, 0, 0
local wdw_curCharges, wdw_maxCharges, wdw_chargeStart, wdw_chargeDuration = 0, 0, 0, 0
local startGCD, durationGCD = 0, 0

local wdw_lookupSpec = { ["Deathknight"] = { "Blood", "Frost", "Unholy"},
			["Demonhunter"] = {"Havoc", "Vengeance"},
			["Druid"] = {"Balance", "Feral", "Guardian", "Restoration"},
			["Hunter"] = {"Beast Mastery", "Marksmanship", "Survival"},
			["Mage"] = {"ArcaneMage", "FireMage", "FrostMage"},
			["Monk"] = {"Brewmaster", "Mistweaver", "Windwalker"},
			["Paladin"] = {"Holy", "Protection", "Retribution"},
			["Priest"] = {"Discipline", "Holy", "Shadow"},
			["Rogue"] = {"Assassination", "Outlaw", "Subtlety"},
			["Shaman"] = {"Elemental", "Enhancement", "Restoration"},
			["Warlock"] = {"Affliction", "Demonology", "Destruction"},
			["Warrior"] = {"Arms", "Fury", "Protection"}}

--[[ ============================== ]]--
--[[     OnUpdate  -  Cooldowns     ]]-- ===================================================================================================
--[[ ============================== ]]--

local ClassCooldownFunction = {}

ClassCooldownFunction.DEATHKNIGHT = function ()

end

ClassCooldownFunction.DEMONHUNTER = function ()

end

ClassCooldownFunction.DRUID = function ()
	-- Cool Aid v2.10 had Savage Defence recharges
end

ClassCooldownFunction.HUNTER = function ()

end

ClassCooldownFunction.MAGE = function ()
	-- Cool Aid v2.10 had the spec replacements for 122 (157980,157981,157997) as recharges, Arcane Charges 36032 stacking debuff,
	-- Fire Blast (<24) and Inferno Blast (>=24) separated by level for a normal cooldown,
	-- Special code for Rune of Power 116011 and its buff 116014
	-- Special code for Incanter's Flow 1463 and its buff 116267
end

ClassCooldownFunction.MONK = function ()

	if ( wdw_spellItemID == 121817 ) then	-- Power Strikes and PS Buff
		if WeDontWipeDB[ wdw_englishClass ][ 121817 ].timerStarts then
			wdw_lowDuration = WeDontWipeDB[ wdw_englishClass ][ 121817 ].cooldown
			local interval  = fmod( ( GetTime() - WeDontWipeDB[ wdw_englishClass ][ 121817 ].timerStarts ), wdw_lowDuration )
			wdw_lowStart = GetTime() - interval
			wdw_lowCD = wdw_lowDuration - interval
		end
	end

	-- Cool Aid v2.10 had recharges: Rising Sun Kick, Renewing Mist, Chi Brew (with 145640 replaced by 115399, Roll/Chi Torpedo
	-- Tigereye Brew buff 125195
end

ClassCooldownFunction.PALADIN = function ()
	-- Cool Aid v2.10 had recharges: Hand of Freedom, Hand of Sacrifice, Hand of Salvation, Hand of Protection
	-- and the buff Bastion of Glory 114637
end

ClassCooldownFunction.PRIEST = function ()
	-- Cool Aid v2.10 had only Angelic Feather recharges
end

ClassCooldownFunction.ROGUE = function ()

end

ClassCooldownFunction.SHAMAN = function ()
	-- Cool Aid v2.10 Glyphed Purify Spirit recharge, Maelstrom Weapon a buff if Enhancement
	-- 73899 with a 114051 buff - Enhancement Shaman Primal Strike with an active Ascendance
	-- 421 with a 114050 buff - Elemental Shaman Chain Lightning with an active Ascendance
	-- both of above checked the buff. icon replaced tto look as it should:
	-- SetTexture(GetSpellTexture(115356)) -- Use the Wind Strike texture Enhancement
	-- SetTexture(GetSpellTexture(114074)) -- Use the Lava Beam texture for Elemental
end

ClassCooldownFunction.WARLOCK = function ()
	-- Cool Aid v2.10 had only Drak Soul recharges for each specialisation, Conflagrate and Hand of Gul'dan recharges, 
end

ClassCooldownFunction.WARRIOR = function ()
	-- Cool Aid v2.10 had only recharges for Shield Block and Charge with Double Time
end

--[[ ==================================== ]]--
--[[     OnUpdate  -  Used by Modules     ]]-- =============================================================================================
--[[ ==================================== ]]--

function WeDontWipe_CooldownLeft( spellItemID )

	-- This function does NOT support 'enabled' spells such as Presence of Mind. Must first check for buffs on player in those cases
	-- This makes sense as by definition the cooldown is 'undefined' until the player actually uses up the stored spell

	-- The cooldown should never be less than the remaining GCD (wdw_GCD) unless the spell ignores the GCD (which does happen)

	local start, duration, enabled
	if ( spellItemID > 0 ) then
		start, duration, enabled = GetSpellCooldown( spellItemID )
	else
		start, duration, enabled = GetItemCooldown( -spellItemID )
	end

	if ( enabled == 0 ) then				-- Zero for Delayed CD spells such as Presence of Mind
		return 0, 0, 0
	end

	if ( start == startGCD ) and ( duration == durationGCD ) then
		return 0, 0, 0
	end

	local cdLeft = round( start + duration - GetTime(), 3 )

	return cdLeft, start, duration
end

--[[ ========================== ]]--
--[[     OnUpdate  -  Queue     ]]-- =======================================================================================================
--[[ ========================== ]]--

local function FillQueue()

	startGCD, durationGCD = GetSpellCooldown( 61304 )	-- Thank you Blizzard for the GCD spell!
	if durationGCD > 0 then
		wdw_GCDtop = durationGCD
		if startGCD > 0 then
			wdw_GCD = wdw_GCDtop - ( GetTime() - startGCD )
		end
	else
		wdw_GCD = 0
	end

--------------------

	for k,v in pairs( wdw_buffsPlayer ) do
		v.ignore = 1
	end
	for i = 1, 40 do
		name, _, _, count, buffType, _, expires, _, _, _, spellID = UnitBuff( "player", i )
		if not name then break end
		if ( expires ~= 0 ) then expires = expires - GetTime() end
		if ( buffType == nil ) or ( buffType == "" ) then buffType = "N/A" end
		if wdw_buffsPlayer[ tostring( spellID ) ] then
			wdw_buffsPlayer[ tostring( spellID ) ].ignore = 0
			wdw_buffsPlayer[ tostring( spellID ) ].count = count
			wdw_buffsPlayer[ tostring( spellID ) ].expires = expires
			wdw_buffsPlayer[ tostring( spellID ) ].type = buffType
		else
			wdw_buffsPlayer[ tostring( spellID ) ] = {["count"] = count, ["expires"] = expires, ["name"] = name, ["type"] = buffType}
		end
	end
	for k,v in pairs( wdw_buffsPlayer ) do
		if ( v.ignore == 1 ) then wdw_buffsPlayer[ k ] = nil end
	end

--------------------

	wdw_trainingDummy = match( ( UnitName( "target" ) or "" ), L["Training Dummy"] ) and true or false

--------------------

	for i = 1, WeDontWipeDB.totalButtons do
		wdw_Queue[ i ] = 0
	end

	local rotLabel = wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ][ "Rotation" ]
	if rotLabel then
		for i=1,#rotLabel do
			wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ][ rotLabel[i] ]()
		end
	end

--------------------

	local spellItemID, lowCD, enabled, recharging, delay, curCharges, maxCharges, chargeStart, chargeDuration, lowStart, lowDuration

	for b = 1, WeDontWipeDB.queueLength do

		spellItemID = wdw_Queue[ b ]

		if spellItemID > 0 then
			_G[ "WeDontWipe_".. b.. "Icon" ]:SetTexture( GetSpellTexture( spellItemID ) )
		else
			_G[ "WeDontWipe_".. b.. "Icon" ]:SetTexture( GetItemIcon( -spellItemID ) )
		end

		--------------------

		if ( WeDontWipeDB[ wdw_englishClass ][ spellItemID ] == nil ) then
			WeDontWipeDB[ wdw_englishClass ][ spellItemID ] = {}
		end
		if ( WeDontWipeDB[ wdw_englishClass ][ spellItemID ].cooldown == nil ) then
			WeDontWipeDB[ wdw_englishClass ][ spellItemID ].cooldown = 0
		end

		lowCD , enabled, recharging, delay = -1, 0, false, false

		-- special cases code goes here. for spells needing individual treatment. Same as the old Cool Aid

		if ( lowCD < 0 ) then

			if ( spellItemID > 0 ) then

				lowStart, lowDuration, enabled = GetSpellCooldown( spellItemID )
				curCharges, maxCharges, chargeStart, chargeDuration = GetSpellCharges( spellItemID )

				if curCharges and maxCharges and ( curCharges < maxCharges ) then
					recharging = true
					lowStart = chargeStart
					lowDuration = chargeDuration
					WeDontWipeDB[ wdw_englishClass ][ spellItemID ].recharge = chargeDuration
				end
			else
				lowStart, lowDuration, enabled = GetItemCooldown( -spellItemID )
			end
		end

		if ( recharging == false ) then
			if ( lowDuration <= 1.5 ) and ( ( WeDontWipeDB[ wdw_englishClass ][ spellItemID ].cooldown > 1.5 ) or
					( WeDontWipeDB[ wdw_englishClass ][ spellItemID ].cooldown == -1 ) ) then
				delay = true
			else
				WeDontWipeDB[ wdw_englishClass ][ spellItemID ].cooldown = lowDuration
			end
		end

		if ( lowCD < 0 ) then			-- >= 0 from a ClassFunction
			if ( enabled == 0 ) then
				lowCD, lowStart, lowDuration = 0, 0, 0
			else
				lowCD = lowStart + lowDuration - GetTime()
				if lowCD < 0 then
					lowCD = 0
				elseif lowCD > 0 then
					lowCD = round( lowCD, 3 )
				end
			end
		end

		if ( lowCD > 0 ) and not delay then

			if ( _G[ "WeDontWipe_".. b ].lowCD == nil ) then
				_G[ "WeDontWipe_".. b ].lowCD = lowCD
				_G[ "WeDontWipe_".. b ].lowStart = lowStart
				if ( WeDontWipeDB.showBlingTexture == true ) then
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawBling( true )
				end
				_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetCooldown( lowStart, lowDuration )
				_G[ "WeDontWipe_".. b ].spellItemID = spellItemID
			elseif ( _G[ "WeDontWipe_".. b ].lowStart < lowStart ) then
				_G[ "WeDontWipe_".. b ].lowCD = lowCD
				_G[ "WeDontWipe_".. b ].lowStart = lowStart
				if ( WeDontWipeDB.showBlingTexture == true ) then
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawBling( true )
				end
				_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetCooldown( lowStart, lowDuration )
				_G[ "WeDontWipe_".. b ].spellItemID = spellItemID
			end

			if ( WeDontWipeDB.showCountdownNumbers == true ) and ( WeDontWipeDB.countdownBeginsAt >= lowCD ) then
				if lowCD > 2 then
					lowCD = round( lowCD, 0 )
					if lowCD > 120 then
						local min, sec = floor( lowCD/60 ), fmod( lowCD, 60 )
						lowCD = min.."m"..sec
					end
				else
					lowCD = round( lowCD, 1 )
				end
				_G[ "WeDontWipe_".. b.. "CooldownText" ]:SetText( lowCD )
			elseif recharging then
				_G[ "WeDontWipe_".. b.. "CooldownText" ]:SetText( curCharges.."->" )
			else
				_G[ "WeDontWipe_".. b.. "CooldownText" ]:SetText( "" )
			end
		else
			if _G[ "WeDontWipe_".. b ].lowCD then
				_G[ "WeDontWipe_".. b ].lowCD = nil
				_G[ "WeDontWipe_".. b ].lowStart = nil
				_G[ "WeDontWipe_".. b.. "CooldownText" ]:SetText( "" )
				if _G[ "WeDontWipe_".. b ].spellItemID ~= spellItemID then
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawBling( false )
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetCooldown( 0, 0 )
				end
				_G[ "WeDontWipe_".. b ].spellItemID = nil
			end
		end
	end
end

--[[ ========================= ]]--
--[[     OnUpdate  -  Main     ]]-- ========================================================================================================
--[[ ========================= ]]--

local function HideButtons( s )

	for b = s, WeDontWipeDB.totalButtons do
		_G[ "WeDontWipe_".. b.. "Text" ]:SetTextColor( 0, 0, 0, 0 )

	--	if  _G[ "WeDontWipe_".. b ]:IsVisible() then
	--		_G[ "WeDontWipe_".. b ]:Hide()
	--		_G[ "WeDontWipe_".. b.. "CooldownText" ]:SetText( "" )
	--	end

		_G[ "WeDontWipe_".. b ]:SetAlpha(0)	-- v5.02 Show/Hide Protection Error Workaround
		_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawBling( false )
		_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetCooldown( 0, 0 )

		if _G[ "WeDontWipe_".. b ]:IsMouseEnabled() then
			_G[ "WeDontWipe_".. b ]:EnableMouse( false )
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------

local initialClearing = false

local function MerelyASetback()

	if ( WeDontWipeDB.showWhileOOC == true ) or ( WeDontWipeDB.showWhileIC == true ) then
		if UnitInVehicle( "player" ) or ( PetBattlesIsInBattle() == true ) or InCinematic() or UnitIsDeadOrGhost( "player" ) then
			HideButtons( 1 )
			initialClearing = false	-- v5.04
			return
		end
	else
		HideButtons( 1 )
		initialClearing = false	-- v5.04
		return
	end

	local inCombat = false
	if UnitAffectingCombat( "player" ) then	-- v5.05. Used to include IsInInstance() test
		inCombat = true
	else
		if UnitCanAttack( "target", "player" ) or UnitCanAttack( "player", "target" ) then
			if not UnitIsDeadOrGhost( "target" ) then
				inCombat = true
			end

		end
	end

	if ( inCombat == true ) then
		if ( WeDontWipeDB.showWhileIC == true ) then

			if ( wdw_hasRotation == true ) then FillQueue() end

			if ( initialClearing == false ) then

				HideButtons( ( wdw_hasRotation == true ) and ( WeDontWipeDB.queueLength + 1) or 1 )
				for b = 1, WeDontWipeDB.queueLength do
					_G[ "WeDontWipe_".. b.. "Text" ]:SetTextColor( 0, 0, 0, 0 )
					if _G[ "WeDontWipe_".. b ]:IsMouseEnabled() then
						_G[ "WeDontWipe_".. b ]:EnableMouse( false )
					end

					if ( wdw_hasRotation == true ) then
						_G[ "WeDontWipe_".. b ]:SetAlpha( 1 )	-- v5.02 Show/Hide Protection Error Workaround
					end

			--		if ( wdw_hasRotation == true ) and not _G[ "WeDontWipe_".. b ]:IsVisible() then
			--			_G[ "WeDontWipe_".. b ]:Show()
			--		end
				end
				initialClearing = true
			end
		else
			HideButtons( 1 )
			return
		end
	else
		initialClearing = false
		if ( WeDontWipeDB.showWhileOOC == true ) then
			for b = 1, WeDontWipeDB.totalButtons do
				_G[ "WeDontWipe_".. b.. "Icon" ]:SetTexture()
				_G[ "WeDontWipe_".. b.. "Text" ]:SetTextColor( WeDontWipeDB.countdownColours.r, 
						WeDontWipeDB.countdownColours.g, WeDontWipeDB.countdownColours.b,
						WeDontWipeDB.countdownColours.a )
				_G[ "WeDontWipe_".. b.. "CooldownText" ]:SetText( "" )

				_G[ "WeDontWipe_".. b ]:SetAlpha( 1 )	-- v5.02 Show/Hide Protection Error Workaround
				_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawBling( false )
				_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetCooldown( 0, 0 )
			--	if not _G[ "WeDontWipe_".. b ]:IsVisible() then
			--		_G[ "WeDontWipe_".. b ]:Show()
			--	end

				if not _G[ "WeDontWipe_".. b ]:IsMouseEnabled() then
					_G[ "WeDontWipe_".. b ]:EnableMouse( true )
				end
			end
		else
			HideButtons( 1 )
			return
		end
	end
end

--[[ ===================== ]]--
--[[     Event Support     ]]-- ============================================================================================================
--[[ ===================== ]]--

local hy_colour_X11Chocolate = "\124cFFD2691E"	-- HardYards chat line prefix colour

local function RotationSetup()

	if not wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Parameters"] then return end

	wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["DB"]()

	for i=1,#wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Parameters"] do
		if (wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Parameters"][i] ~= "List") and
				(wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Parameters"][i] ~= "DB") then
			wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ][ wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Parameters"][i] ]()
		end
	end

	if tostring( GetAddOnMetadata( "WeDontWipe", "Version" ) ) < tostring( wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["WDW Version"] ) then
		printWDW( "(".. "\124cFFFF0000WARNING: ".. wdw_colour_Jasmine.. "Requires ".. wdw_colour_SelectiveYellow.. "We Don't Wipe"..
			wdw_colour_Jasmine.. " v".. wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["WDW Version"].. " or higher)" )
	else
		printWDW( "(Requires ".. wdw_colour_SelectiveYellow.. "We Don't Wipe".. wdw_colour_Jasmine.. " v"..
			wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["WDW Version"].. " or higher)" )
	end

	if wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Hard Yards Version"] then
		if tostring( GetAddOnMetadata( "HardYards", "Version" ) ) < tostring( wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Hard Yards Version"] ) then
			printWDW( "(".. "\124cFFFF0000WARNING: ".. wdw_colour_Jasmine.. "Requires ".. hy_colour_X11Chocolate.. "Hard Yards"..
				wdw_colour_Jasmine.. " v".. wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Hard Yards Version"].. " or higher)" )
		else
			printWDW( "(Requires ".. hy_colour_X11Chocolate.. "Hard Yards".. wdw_colour_Jasmine.. " v"..
				wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Hard Yards Version"].. " or higher)" )
		end
	end
end

local ClassLoginFunction = {}

ClassLoginFunction.DEATHKNIGHT = function ()

end

ClassLoginFunction.DEMONHUNTER = function ()

end

ClassLoginFunction.DRUID = function ()

end

ClassLoginFunction.HUNTER = function ()

end

ClassLoginFunction.MAGE = function ()

end

ClassLoginFunction.MONK = function ()

-- WIP

	if ( WeDontWipeDB[ wdw_englishClass ][ 121817 ] == nil ) then				-- Power Strikes
		WeDontWipeDB[ wdw_englishClass ][ 121817 ] = {}
		WeDontWipeDB[ wdw_englishClass ][ 121817 ].cooldown = 15
	end

	if IsSpellKnown( 121817 ) then				-- Power Strikes
		local found, spellID = false, 0
		for i = 1,40 do
			spellID = select( 11, UnitBuff( "player", i ) )
			if not spellID then break end
			if ( spellID == 129914 ) then		-- Power Strikes buff
				found = true 
				break
			end
		end
		if not found then
			if ( WeDontWipeDB[ wdw_englishClass ][ 121817 ].timerStarts == nil ) or ( wdw_PTU_times > 1 ) then
				local i,f = modf( GetTime() )
				if f > 0.5 then
					i = i + f - 0.5
				end
				WeDontWipeDB[ wdw_englishClass ][ 121817 ].timerStarts = i
			end
		end
	else
		WeDontWipeDB[ wdw_englishClass ][ 121817 ].timerStarts = nil
	end
end

ClassLoginFunction.PALADIN = function ()

end

ClassLoginFunction.PRIEST = function ()

end

ClassLoginFunction.ROGUE = function ()

end

ClassLoginFunction.SHAMAN = function ()

end

ClassLoginFunction.WARLOCK = function ()

end

ClassLoginFunction.WARRIOR = function ()

end

local function ButtonSnap( buttonNumber )

	local buttonName = "WeDontWipe_".. buttonNumber
	local left, top = _G[ buttonName ]:GetLeft(), _G[ buttonName ]:GetTop()		-- AFTER move values. WILL be updated
	local xOriginal = WeDontWipeDB[ tostring( buttonNumber ) ].x	-- BEFORE move values
	local yOriginal = WeDontWipeDB[ tostring( buttonNumber ) ].y

	local right = _G[ buttonName ]:GetRight()
	local bottom = _G[ buttonName ]:GetBottom()
	local xUnSnapped, yUnSnapped = left, top					-- retained AFTER move values. NOT updated
	local xSnapAmount, ySnapAmount = -1, -1

	if WeDontWipeDB.snapToLower and ( buttonNumber > 1 ) then

		for i = buttonNumber, 2, -1 do

			local previousButtonName = "WeDontWipe_".. tostring( ( i - 1 ) )
			local previousLeft, previousRight = _G[ previousButtonName ]:GetLeft(), _G[ previousButtonName ]:GetRight()
			local previousHorizontalMiddle = ( ( previousRight - previousLeft ) / 2 ) + previousLeft
			local previousTop, previousBottom = _G[ previousButtonName ]:GetTop(), _G[ previousButtonName ]:GetBottom()
			local previousVerticalMiddle = ( ( previousTop - previousBottom ) / 2 ) + previousBottom

			if ( xSnapAmount == -1 ) then
				xSnapAmount = ( previousRight - previousLeft ) * WeDontWipeDB.snapLimit
				ySnapAmount = xSnapAmount
			end

			if abs( xUnSnapped - previousLeft ) < xSnapAmount then
				left, xSnapAmount = previousLeft, abs( xUnSnapped - previousLeft )
			elseif abs( xUnSnapped - previousHorizontalMiddle ) < xSnapAmount then
				left, xSnapAmount = previousHorizontalMiddle, abs( xUnSnapped - previousHorizontalMiddle )
			elseif abs( xUnSnapped - previousRight ) < xSnapAmount then
				left, xSnapAmount = previousRight, abs( xUnSnapped - previousRight )
			elseif abs( right - previousHorizontalMiddle ) < xSnapAmount then
				left, xSnapAmount = previousHorizontalMiddle - ( previousRight - previousLeft ), abs( right - previousHorizontalMiddle )
			elseif abs( right - previousLeft ) < xSnapAmount then
				left, xSnapAmount = previousLeft - ( previousRight - previousLeft ), abs( right - previousLeft ) 
			end

			if abs( yUnSnapped - previousTop ) < ySnapAmount then
				top, ySnapAmount = previousTop, abs( yUnSnapped - previousTop )
			elseif abs( yUnSnapped - previousVerticalMiddle ) < ySnapAmount then
				top, ySnapAmount = previousVerticalMiddle, abs( yUnSnapped - previousVerticalMiddle )
			elseif abs( yUnSnapped - previousBottom ) < ySnapAmount then
				top, ySnapAmount = previousBottom, abs( yUnSnapped - previousBottom )
			elseif abs( bottom - previousVerticalMiddle ) < ySnapAmount then
				top, ySnapAmount = previousVerticalMiddle + ( previousTop - previousBottom ), abs( bottom - previousVerticalMiddle )
			elseif abs( bottom - previousTop ) < ySnapAmount then
				top, ySnapAmount = previousTop + ( previousTop - previousBottom ), abs( bottom - previousTop )
			end
		end
	end

	if WeDontWipeDB.snapToHigher and ( buttonNumber < WeDontWipeDB.totalButtons ) then

		for i = buttonNumber, ( WeDontWipeDB.totalButtons - 1 ), -1 do

			local laterButtonName = "WeDontWipe_".. tostring( ( i + 1 ) )
			local laterLeft, laterRight = _G[ laterButtonName ]:GetLeft(), _G[ laterButtonName ]:GetRight()
			local laterHorizontalMiddle = ( ( laterRight - laterLeft ) / 2 ) + laterLeft
			local laterTop, laterBottom = _G[ laterButtonName ]:GetTop(), _G[ laterButtonName ]:GetBottom()
			local laterVerticalMiddle = ( ( laterTop - laterBottom ) / 2 ) + laterBottom

			if ( xSnapAmount == -1 ) then
				xSnapAmount = ( laterRight - laterLeft ) * WeDontWipeDB.snapLimit
				ySnapAmount = xSnapAmount
			end

			if abs( xUnSnapped - laterLeft ) < xSnapAmount then
				left, xSnapAmount = laterLeft, abs( xUnSnapped - laterLeft )
			elseif abs( xUnSnapped - laterHorizontalMiddle ) < xSnapAmount then
				left, xSnapAmount = laterHorizontalMiddle, abs( xUnSnapped - laterHorizontalMiddle )
			elseif abs( xUnSnapped - laterRight ) < xSnapAmount then
				left, xSnapAmount = laterRight, abs( xUnSnapped - laterRight )
			elseif abs( right - laterHorizontalMiddle ) < xSnapAmount then
				left, xSnapAmount = laterHorizontalMiddle - ( laterRight - laterLeft ), abs( right - laterHorizontalMiddle )
			elseif abs( right - laterLeft ) < xSnapAmount then
				left, xSnapAmount = laterLeft - ( laterRight - laterLeft ), abs( right - laterLeft ) 
			end

			if abs( yUnSnapped - laterTop ) < ySnapAmount then
				top, ySnapAmount = laterTop, abs( yUnSnapped - laterTop )
			elseif abs( yUnSnapped - laterVerticalMiddle ) < ySnapAmount then
				top, ySnapAmount = laterVerticalMiddle, abs( yUnSnapped - laterVerticalMiddle )
			elseif abs( yUnSnapped - laterBottom ) < ySnapAmount then
				top, ySnapAmount = laterBottom, abs( yUnSnapped - laterBottom )
			elseif abs( bottom - laterVerticalMiddle ) < ySnapAmount then
				top, ySnapAmount = laterVerticalMiddle + ( laterTop - laterBottom ), abs( bottom - laterVerticalMiddle )
			elseif abs( bottom - laterTop ) < ySnapAmount then
				top, ySnapAmount = laterTop + ( laterTop - laterBottom ), abs( bottom - laterTop )
			end
		end
	end

	if ( WeDontWipeDB.snapToLower and ( buttonNumber > 1 ) ) or ( WeDontWipeDB.snapToHigher and ( buttonNumber <
									WeDontWipeDB.totalButtons ) ) then
		for i = 1, WeDontWipeDB.totalButtons do
			if WeDontWipeDB.snapAllFollowing and ( i >= buttonNumber ) then
				break
			end
			if ( abs( WeDontWipeDB[ tostring( i ) ].x - left ) < 0.1 ) and ( abs( WeDontWipeDB[ tostring( i ) ].y - top ) < 0.1 ) then
				left, top = xOriginal, yOriginal
				break
			end
		end
	end

	WeDontWipeDB[ tostring( buttonNumber ) ].x = left
	WeDontWipeDB[ tostring( buttonNumber ) ].y = top
	_G[ buttonName ]:ClearAllPoints()
	_G[ buttonName ]:SetPoint( "TOPLEFT", WeDontWipeDB[ tostring( buttonNumber ) ].x,
				-( UIParent:GetHeight() - WeDontWipeDB[ tostring( buttonNumber ) ].y ) )

	local xDelta = WeDontWipeDB[ tostring( buttonNumber ) ].x - xOriginal
	local yDelta = WeDontWipeDB[ tostring( buttonNumber ) ].y - yOriginal

	if WeDontWipeDB.snapAllFollowing and ( buttonNumber < WeDontWipeDB.totalButtons ) then

		for i = ( buttonNumber+1 ), WeDontWipeDB.totalButtons do
			WeDontWipeDB[ tostring( i ) ].x = WeDontWipeDB[ tostring( i ) ].x + xDelta
			WeDontWipeDB[ tostring( i ) ].y = WeDontWipeDB[ tostring( i ) ].y + yDelta
			_G[ "WeDontWipe_".. i ]:ClearAllPoints()
			_G[ "WeDontWipe_".. i ]:SetPoint( "TOPLEFT", WeDontWipeDB[ tostring( i ) ].x,
						-( UIParent:GetHeight() - WeDontWipeDB[ tostring( i ) ].y ) )
		end
	end
end

--[[ ========================= ]]--
--[[     Registered Events     ]]-- ========================================================================================================
--[[ ========================= ]]--

local function SpecialisationRotation()

	_, wdw_englishClass = UnitClass( "player" )
	wdw_englishClass = string.sub( wdw_englishClass, 1, 1 ).. string.lower( string.sub( wdw_englishClass, 2 ) )

	if ( WeDontWipeDB[ wdw_englishClass ] == nil ) then WeDontWipeDB[ wdw_englishClass ] = {} end

	local spec = GetSpecialization()
	if spec then
		wdw_currentSpec = wdw_lookupSpec[ wdw_englishClass ][ spec ]
	else
		wdw_currentSpec = "Unknown"
	end

	wdw_hasRotation = false

	if wdwMod_Rotations then
		if wdwMod_Rotations[ wdw_currentSpec ] then
			if wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ] then
				printWDW( "Using the ".. wdw_colour_SelectiveYellow.. WeDontWipeDB.rotation.. wdw_colour_Jasmine..
					" v".. wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Version"].. " rotation" )
				RotationSetup()
				wdw_hasRotation = true
			else
				local firstRotation
				for k,v in pairs( wdwMod_Rotations[ wdw_currentSpec ] ) do
					if ( firstRotation == nil ) then
						firstRotation = k
					else
						printWDW( "Go to the Rotations sub-menu to select a rotation" )
						firstRotation = nil
						break
					end
				end
				if firstRotation then
					WeDontWipeDB.rotation = firstRotation
					printWDW( "The ".. wdw_colour_SelectiveYellow.. WeDontWipeDB.rotation.. wdw_colour_Jasmine..
						" v".. wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ]["Version"]..
						" rotation was selected" )
					RotationSetup()
					wdw_hasRotation = true
				end
			end
		else
			if ( wdw_currentSpec == "Unknown" ) then
				printWDW( "An active specialisation is required" )
			else
				printWDW( "No rotations for your specialisation were found" )
			end
		end
	else
		printWDW( "No rotations were found" )
	end
end

local function PlayerLogin( self )

	-- Let Blizzard do the hard work of scaling. Copy the size of a screen element which has ALREADY loaded. (DON'T use the minimap )
	local scaledFontHeight = GameMenuButtonHelpText:GetStringHeight()

	if ( WeDontWipeDB == nil ) or ( WeDontWipeDB.version0500 == nil ) then
		WeDontWipeDB = {}
		WeDontWipeDB.version0500 = true
	end

	-- Also used for self repair at login

	if ( WeDontWipeDB.snapToLower == nil )			then WeDontWipeDB.snapToLower			= true 	end
	if ( WeDontWipeDB.snapToHigher == nil )			then WeDontWipeDB.snapToHigher			= true 	end
	if ( WeDontWipeDB.snapAllFollowing == nil )		then WeDontWipeDB.snapAllFollowing		= true 	end
	if ( WeDontWipeDB.snapLimit == nil )			then WeDontWipeDB.snapLimit			= 0.15 	end
	if ( WeDontWipeDB.totalButtons == nil )			then WeDontWipeDB.totalButtons			= 10	end
	if ( WeDontWipeDB.queueLength == nil )			then WeDontWipeDB.queueLength			= 6	end
	if ( WeDontWipeDB.buttonSize == nil )			then WeDontWipeDB.buttonSize			= 48	end
	if ( WeDontWipeDB.showWhileIC == nil )			then WeDontWipeDB.showWhileIC			= true	end
	if ( WeDontWipeDB.showWhileOOC == nil )			then WeDontWipeDB.showWhileOOC			= true	end
	if ( WeDontWipeDB.showCountdownNumbers == nil )		then WeDontWipeDB.showCountdownNumbers		= true	end
	if ( WeDontWipeDB.countdownBeginsAt == nil )		then WeDontWipeDB.countdownBeginsAt		= 2	end
	if ( WeDontWipeDB.showEdgeTexture == nil )		then WeDontWipeDB.showEdgeTexture		= true	end
	if ( WeDontWipeDB.edgeTexture == nil )			then WeDontWipeDB.edgeTexture			= "Interface/Cooldown/Edge" end
	if ( WeDontWipeDB.showBlingTexture == nil )		then WeDontWipeDB.showBlingTexture		= true	end
	if ( WeDontWipeDB.blingTexture == nil )			then WeDontWipeDB.blingTexture			= "Interface/Cooldown/Starburst" end
	if ( WeDontWipeDB.countdownColours == nil )		then WeDontWipeDB.countdownColours		= {}	end
	if ( WeDontWipeDB.countdownColours.r == nil )		then WeDontWipeDB.countdownColours.r		= 1	end
	if ( WeDontWipeDB.countdownColours.g == nil )		then WeDontWipeDB.countdownColours.g		= 1	end
	if ( WeDontWipeDB.countdownColours.b == nil )		then WeDontWipeDB.countdownColours.b		= 1	end
	if ( WeDontWipeDB.countdownColours.a == nil )		then WeDontWipeDB.countdownColours.a		= 1	end
	if ( WeDontWipeDB.swipeReverse == nil )			then WeDontWipeDB.swipeReverse			= false	end
	if ( WeDontWipeDB.swipeTextureColours == nil )		then WeDontWipeDB.swipeTextureColours		= {}	end
	if ( WeDontWipeDB.swipeTextureColours.r == nil )	then WeDontWipeDB.swipeTextureColours.r		= 0.004	end
	if ( WeDontWipeDB.swipeTextureColours.g == nil )	then WeDontWipeDB.swipeTextureColours.g		= 0.004	end
	if ( WeDontWipeDB.swipeTextureColours.b == nil )	then WeDontWipeDB.swipeTextureColours.b		= 0.004	end
	if ( WeDontWipeDB.swipeTextureColours.a == nil )	then WeDontWipeDB.swipeTextureColours.a		= 0.8	end
	if ( WeDontWipeDB.rotation == nil )			then WeDontWipeDB.rotation			= "Single" end

	for b = 1, WeDontWipeDB.totalButtons do

		hooksecurefunc( _G[ "WeDontWipe_".. b ], "StopMovingOrSizing", function( self )
			ButtonSnap( b )
		end)

		if not WeDontWipeDB[ tostring( b ) ] then
			WeDontWipeDB[ tostring( b ) ] = {}
		end
		_G[ "WeDontWipe_".. b ]:SetSize( WeDontWipeDB.buttonSize, WeDontWipeDB.buttonSize )
		_G[ "WeDontWipe_".. b.. "Text" ]:SetTextHeight( scaledFontHeight * WeDontWipeDB.buttonSize / 32 )
		_G[ "WeDontWipe_".. b.. "Text" ]:SetTextColor( WeDontWipeDB.countdownColours.r, WeDontWipeDB.countdownColours.g,
			WeDontWipeDB.countdownColours.b, WeDontWipeDB.countdownColours.a )
		_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetSize( WeDontWipeDB.buttonSize, WeDontWipeDB.buttonSize )
		_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetHideCountdownNumbers( true )
		_G[ "WeDontWipe_".. b.. "CooldownText" ]:SetTextHeight( scaledFontHeight * WeDontWipeDB.buttonSize / 32 )
		_G[ "WeDontWipe_".. b.. "CooldownText" ]:SetTextColor( WeDontWipeDB.countdownColours.r, WeDontWipeDB.countdownColours.g,
			WeDontWipeDB.countdownColours.b, WeDontWipeDB.countdownColours.a )

		-- The colour can be set in XML but I couldn't figure out a way of setting the colour from LUA
		if ( WeDontWipeDB.showBlingTexture == true ) then
			_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetBlingTexture( WeDontWipeDB.blingTexture )
			_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawBling( true )
		else
			_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawBling( false )
		end

		-- The colour can be set in XML but I couldn't figure out a way of setting the colour from LUA
		if ( WeDontWipeDB.showEdgeTexture == true ) then
			_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetEdgeTexture( WeDontWipeDB.edgeTexture )
			_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawEdge( true )
		else
			_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawEdge( false )
		end

		-- The colour can be set in XML but I couldn't figure out a way of setting the colour from LUA EXCEPT the ALPHA channel
		_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetSwipeColor( WeDontWipeDB.swipeTextureColours.r, WeDontWipeDB.swipeTextureColours.g,
			WeDontWipeDB.swipeTextureColours.b, WeDontWipeDB.swipeTextureColours.a )
		_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetReverse( WeDontWipeDB.swipeReverse )

		_G[ "WeDontWipe_".. b ]:Show()	-- v5.02 Show/Hide Protection Error Workaround
	end

	if WeDontWipeDB["1"].x and WeDontWipeDB["1"].y then
		_G[ "WeDontWipe_1" ]:ClearAllPoints()
		_G[ "WeDontWipe_1" ]:SetPoint( "TOPLEFT", WeDontWipeDB["1"].x, -( UIParent:GetHeight() - WeDontWipeDB["1"].y ) )
	else
		_G[ "WeDontWipe_1" ]:ClearAllPoints()
		_G[ "WeDontWipe_1" ]:SetPoint( "TOPLEFT", ( ( UIParent:GetWidth() / 4 ) - ( UIParent:GetWidth() / 2 ) ), -( UIParent:GetHeight() / 2 ) )
		WeDontWipeDB["1"].x = _G[ "WeDontWipe_1" ]:GetLeft()
		WeDontWipeDB["1"].y = _G[ "WeDontWipe_1" ]:GetTop()
	end

	for b = 2, WeDontWipeDB.totalButtons do
		if not WeDontWipeDB[ tostring( b ) ].x then
			WeDontWipeDB[ tostring( b ) ].x = WeDontWipeDB[ tostring( b-1 ) ].x + ( WeDontWipeDB.buttonSize / 2 )
		end
		if not WeDontWipeDB[ tostring( b ) ].y then
			WeDontWipeDB[ tostring( b ) ].y = WeDontWipeDB[ tostring( b-1 ) ].y + ( WeDontWipeDB.buttonSize / 2 )
		end

		local xDelta = abs( WeDontWipeDB[ tostring( b ) ].x - WeDontWipeDB[ tostring( b-1 ) ].x )
		local yDelta = abs( WeDontWipeDB[ tostring( b ) ].y - WeDontWipeDB[ tostring( b-1 ) ].y )

		if ( xDelta <= 0.1 ) and ( yDelta <= 0.1 ) then
			if xDelta <= 0.1 then
				 WeDontWipeDB[ tostring( b ) ].x =  WeDontWipeDB[ tostring( b ) ].x + ( WeDontWipeDB.buttonSize / 2 )
			end
			if yDelta <= 0.1 then
				WeDontWipeDB[ tostring( b ) ].y = WeDontWipeDB[ tostring( b ) ].y + ( WeDontWipeDB.buttonSize / 2 )
			end
		end

		_G[ "WeDontWipe_".. b ]:ClearAllPoints()
		_G[ "WeDontWipe_".. b ]:SetPoint( "TOPLEFT",  WeDontWipeDB[ tostring( b ) ].x,
			-( UIParent:GetHeight() -  WeDontWipeDB[ tostring( b ) ].y ) )
	end

	wdw_playerLevel = UnitLevel( "player" )

--	if ( WeDontWipeDB[ wdw_englishClass ] == nil ) then WeDontWipeDB[ wdw_englishClass ] = {} end
--	ClassLoginFunction[ wdw_englishClass ]()
end

--[[ ================================================ ]]--
--[[     Main (Non-Display) Frame Script Handlers     ]]-- =================================================================================
--[[ ================================================ ]]--

local welcomed, wdw_playerLoggedIn = false, false

function WeDontWipe_OnEvent( self, event, ... )

	-- All events registered in the XML file for the non-displayed WeDontWipe frame
	-- Login: PLAYER_TALENT_UPDATE -> PLAYER_SPECIALIZATION_CHANGED -> PLAYER_TALENT_UPDATE x 2 -> PLAYER_LOGIN -> UNIT_NAME_UPDATE
	--	-> ZONE_CHANGED_NEW_AREA -> PLAYER_ENTERING_WORLD
	-- Reload: PLAYER_TALENT_UPDATE -> PLAYER_LOGIN -> PLAYER_ENTERING_WORLD
	-- Specialisation change: PLAYER_TALENT_UPDATE x 2 -> PLAYER_SPECIALIZATION_CHANGED

	if event == "UNIT_SPELLCAST_SUCCEEDED" then
		if (...) == "player" then
			-- login/reload causes some "spells" to trigger here too! Especially 836 LOGINEFFECT. Useful?
			local arg5 = select( 5, ... )
			if ( arg5 ~= 166646 ) then	-- Windwalking spell. Why oh why Blizzard? lol
				wdw_mostRecentSpell = arg5
			end
		end
	elseif event == "PLAYER_REGEN_DISABLED" then
		wdw_mostRecentSpell = 0
	elseif event == "PLAYER_TALENT_UPDATE" then
		wdw_PTU_times = wdw_PTU_times + 1
		-- during a player_Login event, will be == 1 in a Reload situation and >1 in an actual Login situation
	elseif ( event == "PLAYER_SPECIALIZATION_CHANGED" ) then
		if ( wdw_playerLoggedIn == true ) then
			SpecialisationRotation()
			-- too here if an actual specialisation change while playing, rather than triggered during login/reload
		end
	elseif event == "UNIT_NAME_UPDATE" then
		if ( welcomed == false ) then
			local name = UnitPVPName( "player" ) or UnitName( "player" )
			local addonNameVer = "We Don't Wipe v".. tostring( GetAddOnMetadata( addonName, "Version" ) )
			local welcomeText = L["Welcome ~p~ to ~n~"]
			welcomeText = gsub( welcomeText, "~p~" , wdw_colour_SelectiveYellow.. name.. wdw_colour_Jasmine )
			welcomeText = gsub( welcomeText, "~n~" , wdw_colour_SelectiveYellow.. addonNameVer.. wdw_colour_Jasmine )
			printWDW( welcomeText )
			welcomed = true
			if ( WeDontWipeDB.FirstMenuDone == nil ) then
				SlashCmdList.WeDontWipe("?")
				WeDontWipeDB.FirstMenuDone = true
			end
		end
	elseif event == "PLAYER_LOGIN" then
		PlayerLogin( self )
		wdw_playerLoggedIn = true
		SpecialisationRotation()
	end
end

function WeDontWipe_OnUpdate( self, elapsed)

	-- OnUpdate is the way Blizzard's servers come to each AddOn periodically. We name our OnUpdate script handler in the XML file
	-- Entirely up to Blizzard's WoW server as to how often we come here. Every 20 to 50ms is a reasonable expectation
	-- OnUpdate will only invoke if the frame to which it belongs is not hidden
	-- The frame "WeDontWipe" simply has "hidden=false" yet has nothing to actually show!

	self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed
	while self.TimeSinceLastUpdate > ( 1 / GetFramerate() ) do
		MerelyASetback()
		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate - ( 1 / GetFramerate() )
	end
end

--[[ ============================= ]]--
--[[     Slash Commands Support    ]]-- ====================================================================================================
--[[ ============================= ]]--

local function ColourPicker( databaseEntity )

	ColorPickerFrame.originalColours = {}
	ColorPickerFrame.originalColours = { WeDontWipeDB[ databaseEntity ].r, WeDontWipeDB[ databaseEntity ].g,
			WeDontWipeDB[ databaseEntity ].b, WeDontWipeDB[ databaseEntity ].a }

	ColorPickerFrame.func = function()
		local rNew, gNew, bNew = ColorPickerFrame:GetColorRGB()
		WeDontWipeDB[ databaseEntity ].r, WeDontWipeDB[ databaseEntity ].g, WeDontWipeDB[ databaseEntity ].b = rNew, gNew, bNew
		WeDontWipeDB[ databaseEntity ].r = round( WeDontWipeDB[ databaseEntity ].r, 3)
		WeDontWipeDB[ databaseEntity ].g = round( WeDontWipeDB[ databaseEntity ].g, 3)
		WeDontWipeDB[ databaseEntity ].b = round( WeDontWipeDB[ databaseEntity ].b, 3)
		WeDontWipeDB[ databaseEntity ].a = round( OpacitySliderFrame:GetValue(), 3 )
		WeDontWipe_ColourPickerPostClick( databaseEntity )
	end

	ColorPickerFrame.hasOpacity = true
	ColorPickerFrame.opacity = WeDontWipeDB[ databaseEntity ].a

	if ( WeDontWipeDB[ databaseEntity ].r == 0 ) and ( WeDontWipeDB[ databaseEntity ].g == 0 ) and ( WeDontWipeDB[ databaseEntity ].b == 0 ) then
		ColorPickerFrame:SetColorRGB( 0.004, 0.004, 0.004 )
	else
		ColorPickerFrame:SetColorRGB( WeDontWipeDB[ databaseEntity ].r, WeDontWipeDB[ databaseEntity ].g, WeDontWipeDB[ databaseEntity ].b )
	end

	ColorPickerFrame.cancelFunc = function()
		WeDontWipeDB[ databaseEntity ].r, WeDontWipeDB[ databaseEntity ].g, WeDontWipeDB[ databaseEntity ].b, WeDontWipeDB[ databaseEntity ].a =
			unpack( ColorPickerFrame.originalColours[ tostring( g ) ] )
 	end

	ColorPickerFrame:Show()
end

local function OnItsOwn( parm )

	local parm = wdw_colour_SelectiveYellow.. parm.. wdw_colour_Jasmine
	local onItsOwnText = L["~n~ on its own is not allowed"]
	onItsOwnText = gsub( onItsOwnText, "~n~" , parm )
	printWDW( onItsOwnText )
end

--[[ ====================== ]]--
--[[     Slash Commands     ]]-- ===========================================================================================================
--[[ ====================== ]]--

SLASH_WeDontWipe1, SLASH_WeDontWipe2, SLASH_WeDontWipe3 = "/wedontwipe", "/wdw", "/wipe"

local function Slash( options )

	local firstParm, firstParm3, secondParm, secondParm3, thirdParm, thirdParm3, fourthParm, fourthParm3

	for v in gmatch( options, "%S+" ) do
		v = lower( v )
		if not firstParm3 then
			firstParm = v
			firstParm3 = sub( v,1,3 )
		elseif not secondParm3 then
			secondParm = v
			secondParm3 = sub( v,1,3 )
		elseif not thirdParm3 then
			thirdParm = v
			thirdParm3 = sub( v,1,3 )
		else
			fourthParm = v
			fourthParm3 = sub( v,1,3 )
			break
		end
	end

	if ( firstParm3 == "hel" ) or ( firstParm3 == "?" ) or ( firstParm3 == nil ) then

		printWDW( "Main Menu: ".. wdw_colour_MalachiteGreen.. "/wdw ...\n"..
			wdw_colour_MalachiteGreen.. "ic".. wdw_colour_Jasmine.. " = TOGGLE show while IN COMBAT\n"..
			wdw_colour_MalachiteGreen.. "ooc".. wdw_colour_Jasmine.. " = TOGGLE show/edit while OUT OF COMBAT\n\n"..
			wdw_colour_MalachiteGreen.. "len".. wdw_colour_Jasmine.. " = length of the rotation/queue\n\n"..
			wdw_colour_MalachiteGreen.. "snap".. wdw_colour_Jasmine.. " = Button Snap and Size Menu\n"..
			wdw_colour_MalachiteGreen.. "anim".. wdw_colour_Jasmine.. " = Countdown Animation Menu\n"..
			wdw_colour_MalachiteGreen.. "rot".. wdw_colour_Jasmine.. " = Rotation Menu\n"..
			wdw_colour_MalachiteGreen.. "extra".. wdw_colour_Jasmine.. " = Extra Commands Menu\n\n"..
			wdw_colour_MalachiteGreen.. "con".. wdw_colour_Jasmine.. " = List configuration setings" )

	elseif ( firstParm3 == "con" ) then
		printWDW( wdw_colour_MalachiteGreen.. "Configuration:\n"..
			wdw_colour_Jasmine.. "Version: ".. wdw_colour_MalachiteGreen..
				tostring( GetAddOnMetadata( "WeDontWipe", "Version" ) ).. "\n"..
			wdw_colour_Jasmine.. "Number of buttons: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.totalButtons.. "\n"..
			wdw_colour_Jasmine.. "Queue Length: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.queueLength.. "\n"..
			wdw_colour_Jasmine.. "Button size: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.buttonSize.. "\n"..
			wdw_colour_Jasmine.. "Snap to Lower: ".. wdw_colour_MalachiteGreen..
				( ( WeDontWipeDB.snapToLower == true ) and "Yes" or "No" ).. "\n"..
			wdw_colour_Jasmine.. "Snap to Higher: ".. wdw_colour_MalachiteGreen..
				( ( WeDontWipeDB.snapToHigher == true ) and "Yes" or "No" ).. "\n"..
			wdw_colour_Jasmine.. "Snap All Following: ".. wdw_colour_MalachiteGreen..
				( ( WeDontWipeDB.snapAllFollowing == true ) and "Yes" or "No" ).. "\n"..
			wdw_colour_Jasmine.. "Snap Limit: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.snapLimit.. "\n"..
			wdw_colour_Jasmine.. "Show while in combat: ".. wdw_colour_MalachiteGreen..
				( ( WeDontWipeDB.showWhileIC == true ) and "Yes" or "No" ).. "\n"..
			wdw_colour_Jasmine.. "Show while out of combat: ".. wdw_colour_MalachiteGreen..
				( ( WeDontWipeDB.showWhileOOC == true ) and "Yes" or "No" ).. "\n"..
			wdw_colour_Jasmine.. "Show countdown seconds: ".. wdw_colour_MalachiteGreen..
				( ( WeDontWipeDB.showCountdownNumbers == true ) and "Yes" or "No" ).. "\n"..
			wdw_colour_Jasmine.. "Countdown from: ".. wdw_colour_MalachiteGreen..
				( ( WeDontWipeDB.showCountdownNumbers == true ) and WeDontWipeDB.countdownBeginsAt or "Not Applicable" )..
				wdw_colour_Jasmine.. "s\n"..
			wdw_colour_Jasmine.. "Countdown colours: R=".. wdw_colour_MalachiteGreen.. WeDontWipeDB.countdownColours.r..
				wdw_colour_Jasmine.. " G=".. wdw_colour_MalachiteGreen.. WeDontWipeDB.countdownColours.g..
				wdw_colour_Jasmine.. " B=".. wdw_colour_MalachiteGreen.. WeDontWipeDB.countdownColours.b..
				wdw_colour_Jasmine.. " A=".. wdw_colour_MalachiteGreen.. WeDontWipeDB.countdownColours.a..
				" \124c".. format( "FF%02x%02x%02x",  WeDontWipeDB.countdownColours.r * 255,
				WeDontWipeDB.countdownColours.g * 255, WeDontWipeDB.countdownColours.b * 255).. "123456\n"..
			wdw_colour_Jasmine.. "Swipe texture opacity: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.swipeTextureColours.a.. "\n"..
			wdw_colour_Jasmine.. "Invert/reverse Swipe: ".. wdw_colour_MalachiteGreen..
				( ( WeDontWipeDB.swipeReverse == true ) and "Yes" or "No" ).. "\n"..
			wdw_colour_Jasmine.. "Edge texture: ".. wdw_colour_MalachiteGreen..
				( ( WeDontWipeDB.showEdgeTexture == true ) and WeDontWipeDB.edgeTexture or "No edge texture shown" ).. "\n"..
			wdw_colour_Jasmine.. "Bling texture: ".. wdw_colour_MalachiteGreen..
				( ( WeDontWipeDB.showBlingTexture == true ) and WeDontWipeDB.blingTexture or "No bling texture shown" ) )

	elseif ( firstParm3 == "ic" ) then
		if ( secondParm == "?" ) then
			printWDW( "The rotation will be shown when in combat or if combat is likely, such as being present in a dungeon. "..
				"If toggled off, then minimal CPU power and time will be used. When toggled on, the rotation icons "..
				"cannot be clicked or moved. Mouse clicks will go through to whatever is behind." )
		else
			WeDontWipeDB.showWhileIC = not WeDontWipeDB.showWhileIC
		end
		printWDW( "Show while in combat: ".. wdw_colour_MalachiteGreen.. ( ( WeDontWipeDB.showWhileIC == true ) and "Yes" or "No" ) )

	elseif ( firstParm3 == "ooc" ) then
		if ( secondParm == "?" ) then
			printWDW( "You must be out of combat to adjust your rotation icons. Mouse clicks / moves will be enabled. If "..
				"you (unexpectedly) go into combat then this mode is disabled. Merely being in a dungeon or battleground "..
				"counts as being in combat. Think of this as \"edit mode\"" )
		else
			WeDontWipeDB.showWhileOOC = not WeDontWipeDB.showWhileOOC
		end
		printWDW( "Show while out of combat: ".. wdw_colour_MalachiteGreen.. ( ( WeDontWipeDB.showWhileOOC == true ) and "Yes" or "No" ) )

	elseif ( firstParm3 == "len" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			local queueLength = tonumber( secondParm ) or 0
			if ( queueLength >= 1 ) and ( queueLength <= WeDontWipeDB.totalButtons ) then
				WeDontWipeDB.queueLength = queueLength
			else
				printFormat = true
			end
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw len n".. wdw_colour_Jasmine..
				" where the queue length \"n\" will be some amount between 1 and the total buttons defined within the "..
				"AddOn (".. WeDontWipeDB.totalButtons.. "). The longer the shown queue, the greater the cpu / fps "..
				"impact. If ever the WoW Server responds that the AddOn used too much time/cpu then you should shorten "..
				"the queue. A long queue allows you to see your abilities coming off cooldown" )
		end
		printWDW( "Queue Length: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.queueLength )

--------------------------------------------------------------------------------------------------------------------------------------------

	elseif ( firstParm3 == "sna" ) then
		printWDW( "Snap & Size Menu: ".. wdw_colour_MalachiteGreen.. "/wdw ...\n".. wdw_colour_Jasmine..
			"A \"?\" following a parameter will request more detailed information. A parameter inside \"[]\" is optional\n\n"..
			wdw_colour_MalachiteGreen.. "size s".. wdw_colour_Jasmine.. " = Set button size. \"s\" is 15 to 100\n"..
			wdw_colour_MalachiteGreen.. "sl y/t or n/f".. wdw_colour_Jasmine.. " = yes/true or no/false to snap to lower numbered button\n"..
			wdw_colour_MalachiteGreen.. "sh y/t or n/f".. wdw_colour_Jasmine.. " = yes/true or no/false to snap to higher numbered button\n"..
			wdw_colour_MalachiteGreen.. "sf y/t or n/f".. wdw_colour_Jasmine.. " = higher numbered buttons follow button drag\n"..
			wdw_colour_MalachiteGreen.. "slr n".. wdw_colour_Jasmine.. " = set your own Snap Limit ratio to force buttons to snap together\n"..
			wdw_colour_MalachiteGreen.. "sld".. wdw_colour_Jasmine.. " = set the Snap Limit to a comfortable default ratio of 0.15" )

	elseif ( firstParm3 == "siz" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			local size = tonumber( secondParm ) or 0
			if ( size >= 15 ) and ( size <= 100 ) then
				for b = 1, WeDontWipeDB.totalButtons do
					_G[ "WeDontWipe_".. b ]:SetSize( size, size )
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetSize( size, size )
					_G[ "WeDontWipe_".. b.."Text" ]:SetTextHeight(
								GameMenuButtonHelpText:GetStringHeight() * size / 32 )
					_G[ "WeDontWipe_".. b.."CooldownText" ]:SetTextHeight(
								GameMenuButtonHelpText:GetStringHeight() * size / 32 )
				end
				WeDontWipeDB.buttonSize = size
			else
				printFormat = true
			end
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw size s".. wdw_colour_Jasmine..
					" where \"s\" is 15 to 100. (The original size is 48)" )
		end
		printWDW( "Button size: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.buttonSize )

	elseif ( firstParm3 == "sl" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			local action = ""
			if ( secondParm == "y" ) or ( secondParm == "t" ) or
							( secondParm3 == "yes" ) or ( secondParm3 == "tru" ) then
				action = "y"
			elseif ( secondParm == "n" ) or ( secondParm == "f" ) or
							( secondParm3 == "no" ) or ( secondParm3 == "fal" ) then
				action = "n"
			end
			if ( action == "y" ) then
				WeDontWipeDB.snapToLower = true
			elseif ( action == "n" ) then
				WeDontWipeDB.snapToLower = false
			else
				printFormat = true
			end
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw sl y/t or n/f".. wdw_colour_Jasmine..
					" (yes/y/true/t or no/n/false/f) to cause a button you are moving to \"snap\" or be pulled "..
					"like a magnet to a LOWER numbered button so as to sit neatly next to it. Snapping occurs at "..
					"the edges, halfway along an edge, and at the centre" )
		end
		printWDW( "Snap to Lower: ".. wdw_colour_MalachiteGreen.. ( ( WeDontWipeDB.snapToLower == true ) and "Yes" or "No" ) )

	elseif ( firstParm3 == "sh" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			local action = ""
			if secondParm then
				if ( secondParm == "y" ) or ( secondParm == "t" ) or
							( secondParm3 == "yes" ) or ( secondParm3 == "tru" ) then
					action = "y"
				elseif ( secondParm == "n" ) or ( secondParm == "f" ) or
							( secondParm3 == "no" ) or ( secondParm3 == "fal" ) then
					action = "n"
				end
			end
			if ( action == "y" ) then
				WeDontWipeDB.snapToHigher = true
			elseif ( action == "n" ) then
				WeDontWipeDB.snapToHigher = false
			else
				printFormat = true
			end
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw sl y/t or n/f".. wdw_colour_Jasmine..
					" (yes/y/true/t or no/n/false/f) to cause a button you are moving to \"snap\" or be pulled "..
					"like a magnet to a HIGHER numbered button so as to sit neatly next to it. Snapping occurs at "..
					"the edges, halfway along an edge, and at the centre" )
		end
		printWDW( "Snap to Higher: ".. wdw_colour_MalachiteGreen.. ( ( WeDontWipeDB.snapToHigher == true ) and "Yes" or "No" ) )

	elseif ( firstParm3 == "sf" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			local action = ""
			if secondParm then
				if ( secondParm == "y" ) or ( secondParm == "t" ) or
							( secondParm3 == "yes" ) or ( secondParm3 == "tru" ) then
					action = "y"
				elseif ( secondParm == "n" ) or ( secondParm == "f" ) or
							( secondParm3 == "no" ) or ( secondParm3 == "fal" ) then
					action = "n"
				end
			end
			if ( action == "y" ) then
				WeDontWipeDB.snapAllFollowing = true
			elseif ( action == "n" ) then
				WeDontWipeDB.snapAllFollowing = false
			else
				printFormat = true
			end
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw sf y/t or n/f".. wdw_colour_Jasmine..
					" (yes/y/true/t or no/n/false/f)\124cFF1E90FF to request that all HIGHER numbered buttons will "..
					"be DRAGGED WITH a lower numbered button. The higher numbered buttons will \"follow\" the lower "..
					"numbered button" )
		end
		printWDW( "Snap All Following: ".. wdw_colour_MalachiteGreen.. ( ( WeDontWipeDB.snapAllFollowing == true ) and "Yes" or "No" ) )

	elseif ( firstParm3 == "slr" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			local ratio = -1
			if tonumber( secondParm ) then
				ratio = tonumber( secondParm )
			end
			if ( ratio > 0 ) or ( ratio < 0.25 ) then
				WeDontWipeDB.snapLimit = ratio
			else
				printFormat = true
			end
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw slr ratio".. wdw_colour_Jasmine..
					" where the ratio is greater than zero and less than 0.25. A higher value means that the button "..
					"is more sensitive to the magnet like effect of being dragged alongside another button. 0.25 "..
					"means a quarter of the button's height/width. Snap occurs at the corners and centre of a "..
					"button, thus the ratio must always be < 0.25" )
		end
		printWDW( "Snap Limit: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.snapLimit )

	elseif ( firstParm3 == "sld" ) then
		local printFormat = false
		if secondParm and ( secondParm == "?" ) then
			printFormat = true
		else
			WeDontWipeDB.snapLimit = 0.15
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw sld".. wdw_colour_Jasmine..
					" with the Snap Limit set to a comfortable default of 0.15 " )
		end
		printWDW( "Snap Limit: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.snapLimit )

--------------------------------------------------------------------------------------------------------------------------------------------

	elseif ( firstParm3 == "ani" ) then
		printWDW( "Countdown Animation Menu: ".. wdw_colour_MalachiteGreen.. "/wdw ...\n".. wdw_colour_Jasmine..
			"A \"?\" following a parameter will request more detailed information. A parameter inside \"[]\" is optional\n\n"..
			wdw_colour_MalachiteGreen.. "num s/h".. wdw_colour_Jasmine.. " = Show/Hide Countdown numbers\n"..
			wdw_colour_MalachiteGreen.. "cnr n".. wdw_colour_Jasmine.. " = Countdown numbers with n remaining seconds (default 2s)\n\n"..
			wdw_colour_MalachiteGreen.. "cnc".. wdw_colour_Jasmine.. " = Countdown numbers colour selector\n"..
			wdw_colour_MalachiteGreen.. "cncd".. wdw_colour_Jasmine.. " = Restore countdown numbers colour default\n\n"..
			wdw_colour_MalachiteGreen.. "sto".. wdw_colour_Jasmine.. " = Swipe texture opacity selector\n"..
			wdw_colour_MalachiteGreen.. "stod".. wdw_colour_Jasmine.. " = Restore swipe texture opacity default\n"..
			wdw_colour_MalachiteGreen.. "si i/n".. wdw_colour_Jasmine.. " = Invert/reverse the Swipe animation, \"i\"=invert, \"n\"=normal\n\n"..
			wdw_colour_MalachiteGreen.. "et [t]".. wdw_colour_Jasmine.. " = Set a sweeping edge texture. No \"t\" = remove and don't show\n"..
			wdw_colour_MalachiteGreen.. "etd wdw/wow".. wdw_colour_Jasmine.. " = Restore the WDW or WoW edge texture default\n\n"..
			wdw_colour_MalachiteGreen.. "bt [t]".. wdw_colour_Jasmine.. " = Set a bling texture. No \"t\" = remove and don't show\n"..
			wdw_colour_MalachiteGreen.. "btd wdw/wow".. wdw_colour_Jasmine.. " = Restore the WDW or WoW bling texture default" )

	elseif ( firstParm3 == "num" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			local action = ""
			if secondParm then
				if ( secondParm == "s" ) or ( secondParm3 == "sho" ) then
					action = "s"
				elseif ( secondParm == "h" ) or ( secondParm3 == "hid" ) then
					action = "h"
				end
			end
			if ( action == "s" ) then
				WeDontWipeDB.showCountdownNumbers = true
			elseif ( action == "h" ) then
				WeDontWipeDB.showCountdownNumbers = false
			else
				printFormat = true
			end
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw num s/h".. wdw_colour_Jasmine..
					" (s/show or h/hide) to request a countdown of remaining seconds. Note that Blizzard's servers "..
					"may also superimpose a similar countdown. The WDW countdown is more fully featured" )
		end
		printWDW( "Show Countdown Seconds: ".. wdw_colour_MalachiteGreen.. ( ( WeDontWipeDB.showCountdownNumbers == true ) and "Yes" or "No" ) )

	elseif ( firstParm3 == "cnr" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			if secondParm then
				if tonumber( secondParm ) then
					local remainder = tonumber( secondParm )
					if remainder > 0 then
						WeDontWipeDB.countdownBeginsAt = remainder
					else
						printFormat = true
					end
				else
					printFormat = true
				end
			else
				printFormat = true
			end
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw cnr n".. wdw_colour_Jasmine..
					" where \"n\" is the number of remaining seconds from when to commence a countdown. This "..
					"need not necessarily be whole seconds. A value of \"1.5\" would be valid." )
		end
		printWDW( "Countdown from: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.countdownBeginsAt.. "s" )

	elseif ( firstParm3 == "cnc" ) then
		local printFormat = false
		if secondParm and ( secondParm == "?" ) then
			printFormat = true
		elseif ( firstParm == "cncd" ) then
			WeDontWipeDB.countdownColours.r = 1
			WeDontWipeDB.countdownColours.g = 1
			WeDontWipeDB.countdownColours.b = 1
			WeDontWipeDB.countdownColours.a = 1
		else
			ColourPicker( "countdownColours" )
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw cnc".. wdw_colour_Jasmine..
				" and the standard WoW Colour Picker will appear. Use \"/wdw cncd\" instead to restore defaults. This is "..
				"for the colour of the overlaid countdown numbers" )
		else
			for b = 1, WeDontWipeDB.totalButtons do
				_G[ "WeDontWipe_".. b.. "Text" ]:SetTextColor( WeDontWipeDB.countdownColours.r, 
					WeDontWipeDB.countdownColours.g, WeDontWipeDB.countdownColours.b,
					WeDontWipeDB.countdownColours.a )
				_G[ "WeDontWipe_".. b.. "CooldownText" ]:SetTextColor(
					WeDontWipeDB.countdownColours.r, WeDontWipeDB.countdownColours.g,
					WeDontWipeDB.countdownColours.b, WeDontWipeDB.countdownColours.a )
			end
		end
		printWDW( "Countdown Colours: R=".. wdw_colour_MalachiteGreen.. WeDontWipeDB.countdownColours.r..
			wdw_colour_Jasmine.. " G=".. wdw_colour_MalachiteGreen.. WeDontWipeDB.countdownColours.g..
			wdw_colour_Jasmine.. " B=".. wdw_colour_MalachiteGreen.. WeDontWipeDB.countdownColours.b..
			wdw_colour_Jasmine.. " A=".. wdw_colour_MalachiteGreen.. WeDontWipeDB.countdownColours.a..
			" \124c".. format( "FF%02x%02x%02x",  WeDontWipeDB.countdownColours.r * 255,
			WeDontWipeDB.countdownColours.g * 255, WeDontWipeDB.countdownColours.b * 255).. "123456" )

	elseif ( firstParm3 == "sto" ) then
		local printFormat = false
		if secondParm and ( secondParm == "?" ) then
			printFormat = true
		elseif ( firstParm == "stod" ) then
			WeDontWipeDB.swipeTextureColours.r = 0.004
			WeDontWipeDB.swipeTextureColours.g = 0.004
			WeDontWipeDB.swipeTextureColours.b = 0.004
			WeDontWipeDB.swipeTextureColours.a = 0.8
		else
			printWDW( "Note that the WoW server will ignore your COLOUR choices" )
			ColourPicker( "swipeTextureColours" )
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw sto".. wdw_colour_Jasmine..
				" and the standard WoW Colour Picker will appear. Use \"/wdw stod\" instead to restore defaults. This is "..
				"for the OPACITY of the overlaid \"swipe\" texture. (The WoW server will ignore your colour choices)" )
		else
			for b = 1, WeDontWipeDB.totalButtons do
				_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetSwipeColor(
					WeDontWipeDB.swipeTextureColours.r, WeDontWipeDB.swipeTextureColours.g,
					WeDontWipeDB.swipeTextureColours.b, WeDontWipeDB.swipeTextureColours.a )
			end
		end
		printWDW( "Swipe texture opacity: ".. wdw_colour_MalachiteGreen.. WeDontWipeDB.swipeTextureColours.a )

	elseif ( firstParm3 == "si" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			local action = ""
			if secondParm then
				if ( secondParm == "i" ) or ( secondParm3 == "inv" ) or ( secondParm == "r" ) or ( secondParm3 == "rev" ) then
					action = "i"
				elseif ( secondParm == "n" ) or ( secondParm3 == "nor" ) then
					action = "n"
				end
			end
			if ( action == "i" ) then
				WeDontWipeDB.swipeReverse = true
			elseif ( action == "n" ) then
				WeDontWipeDB.swipeReverse = false
			else
				printFormat = true
			end
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw si i/n".. wdw_colour_Jasmine..
					" (i/invert or n/normal) to request the swipe animation to be inverted / reversed or restored to "..
					"the normal direction / animation" )
		end
		printWDW( "Invert/reverse Swipe: ".. wdw_colour_MalachiteGreen.. ( ( WeDontWipeDB.swipeReverse == true ) and "Yes" or "No" ) )

	elseif ( firstParm3 == "etd" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		elseif ( secondParm == "wdw" ) then
			WeDontWipeDB.edgeTexture = "Interface/Cooldown/edge"
			WeDontWipeDB.showEdgeTexture = true
		elseif ( secondParm == "wow" ) then
			WeDontWipeDB.showEdgeTexture = false
		else
			printFormat = true
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw etd wdw/wow".. wdw_colour_Jasmine..
				" where \"wdw\" will add a glowing edge to the cooldown swipe \"hand\" (some expansion ago this was "..
				"the standard Blizzard animation), or \"wow\" will use the current WoW default (which in truth is to "..
				"NOT show any special edge at all). Use \"/wdw et [t]\" to submit your own edge texture" )
		else
			for b = 1, WeDontWipeDB.totalButtons do
				if ( WeDontWipeDB.showEdgeTexture == true ) then
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetEdgeTexture( WeDontWipeDB.edgeTexture )
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawEdge( true )
				else
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawEdge( false )
				end
			end
		end
		printWDW( "Edge texture: ".. wdw_colour_MalachiteGreen..
			( ( WeDontWipeDB.showEdgeTexture == true ) and WeDontWipeDB.edgeTexture or "No edge texture shown" ) )

	elseif ( firstParm3 == "et" ) then
		local printFormat = false
		if not secondParm then
			WeDontWipeDB.showEdgeTexture = false
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			WeDontWipeDB.showEdgeTexture = true
			WeDontWipeDB.edgeTexture = secondParm
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw et [t]".. wdw_colour_Jasmine..
				" where [t] is optional and the name of a texture file you placed into the WDW AddOn folder. E.g. a "..
				"texture file named \"Arrow\" (the file extension is not required) would be specified as: \"/wdw et "..
				"Arrow\". No [t] means any previously specified file is no longer to be used. You will revert to the "..
				"current WoW default of no texture file." )
		else
			for b = 1, WeDontWipeDB.totalButtons do
				if ( WeDontWipeDB.showEdgeTexture == true ) then
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetEdgeTexture( WeDontWipeDB.edgeTexture )
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawEdge( true )
				else
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetEdgeTexture( nil )
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawEdge( false )
				end
			end
		end
		printWDW( "Edge texture: ".. wdw_colour_MalachiteGreen..
			( ( WeDontWipeDB.showEdgeTexture == true ) and WeDontWipeDB.edgeTexture or "No edge texture" ) )
		if ( WeDontWipeDB.showEdgeTexture == true ) then
			printWDW( "If this file was newly added to the WDW folder then you must quit WoW completely and relaunch the game" )
		end

	elseif ( firstParm3 == "btd" ) then
		local printFormat = false
		if not secondParm then
			OnItsOwn( firstParm )
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		elseif ( secondParm == "wdw" ) then
			WeDontWipeDB.blingTexture = "Interface/Cooldown/starburst"
			WeDontWipeDB.showBlingTexture = true
		elseif ( secondParm == "wow" ) then
			WeDontWipeDB.blingTexture = "Interface/Cooldown/star4"
			WeDontWipeDB.showBlingTexture = true
		else
			printFormat = true
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw btd wdw/wow".. wdw_colour_Jasmine..
				" where \"wdw\" or \"wow\" will each add a sparkly \"bling\" effect when a cooldown has completed. The "..
				"WDW alternative being the more spectacular of the two. The WoW option is the game's default." )
		else
			for b = 1, WeDontWipeDB.totalButtons do
				_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetBlingTexture( WeDontWipeDB.blingTexture )
				_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawBling( true )
			end
		end
		printWDW( "Bling texture: ".. wdw_colour_MalachiteGreen..
			( ( WeDontWipeDB.showBlingTexture == true ) and WeDontWipeDB.blingTexture or "No bling texture shown" ) )

	elseif ( firstParm3 == "bt" ) then
		local printFormat = false
		if not secondParm then
			WeDontWipeDB.showBlingTexture = false
		elseif ( secondParm == "?" ) then
			printFormat = true
		else
			WeDontWipeDB.showBlingTexture = true
			WeDontWipeDB.blingTexture = secondParm
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw bt [t]".. wdw_colour_Jasmine..
				" where [t] is optional and the name of a texture file you placed into the WDW AddOn folder. E.g. a "..
				"texture file named \"Stars\" (the file extension is not required) would be specified as: \"/wdw bt "..
				"Stars\". No [t] means no bling at all" )
		else
			for b = 1, WeDontWipeDB.totalButtons do
				if ( WeDontWipeDB.showBlingTexture == true ) then
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetBlingTexture( WeDontWipeDB.blingTexture )
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawBling( true )
				else
					_G[ "WeDontWipe_".. b.. "Cooldown" ]:SetDrawBling( false )
				end
			end
		end
		printWDW( "Bling texture: ".. wdw_colour_MalachiteGreen..
			( ( WeDontWipeDB.showBlingTexture == true ) and WeDontWipeDB.blingTexture or "No bling texture" ) )
		if ( WeDontWipeDB.showBlingTexture == true ) then
			printWDW( "If this file was newly added to the WDW folder then you must quit WoW completely and relaunch the game" )
		end

--------------------------------------------------------------------------------------------------------------------------------------------

	elseif ( firstParm3 == "rot" ) then
		printWDW( "Rotation Menu: ".. wdw_colour_MalachiteGreen.. "/wdw ...\n".. wdw_colour_Jasmine..
			wdw_colour_MalachiteGreen.. "listr".. wdw_colour_Jasmine.. " = List possible rotations\n"..
			wdw_colour_MalachiteGreen.. "sel r".. wdw_colour_Jasmine.. " = Select a rotation\n\n"..
			wdw_colour_MalachiteGreen.. "listp".. wdw_colour_Jasmine.. " = List any rotation customisation parameters\n"..
			wdw_colour_MalachiteGreen.. "setr ".. wdw_colour_Jasmine.. " = Set a rotation parameter" )

	elseif firstParm == "listr" then
		printWDW( "Rotations:")
		for k,v in pairs( wdwMod_Rotations[ wdw_currentSpec ] ) do
			printWDW( k )
		end

	elseif firstParm3 == "sel" then
		local printFormat = false
		if not secondParm then
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw sel s".. wdw_colour_Jasmine..
				" where \"s\" is the name of a rotation. Use the \"/wdw lis\" command to see available rotations" )
		else
			if wdwMod_Rotations then
				if wdwMod_Rotations[ wdw_currentSpec ] then
					if wdwMod_Rotations[ wdw_currentSpec ][ secondParm ] then
						WeDontWipeDB.rotation = secondParm
						printWDW( "Using the ".. wdw_colour_SelectiveYellow.. WeDontWipeDB.rotation..
							wdw_colour_Jasmine.. " rotation" )
					else
						printWDW( "Could not find that rotation. If you newly downloaded the rotation then "..
							"simply drop its folder into the WoW \"AddOns\" folder, log out of WoW, "..
							"then log back in and WDW will then be able to find the new rotation" )
					end
				else
					if ( wdw_currentSpec == "Unknown" ) then
						printWDW( "An active specialisation is required" )
					else
						printWDW( "No rotations for your specialisation were found" )
					end
				end
			else
				printWDW( "No rotations were found" )
			end
		end

	elseif firstParm == "listp" then
		if wdwMod_Rotations and wdwMod_Rotations[ wdw_currentSpec ] and wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ] then
			if wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ][ "Parameters" ] then
				wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ][ "List" ]()
			else
				printWDW( "This rotation does not have customisation parameters" )
			end
		else
			printWDW( "Unable to list customisation parameters as there is no active rotation" )
		end

	elseif firstParm == "setr" then
		local printFormat = false
		if not secondParm then
			printFormat = true
		elseif ( secondParm == "?" ) then
			printFormat = true
		end
		if ( printFormat == true ) then
			printWDW( "Format: ".. wdw_colour_MalachiteGreen.. "/wdw setr name=value,name2=value2,...".. wdw_colour_Jasmine..
				" to set one or more parameters and use \"/wdw listp\" to see a list of possible parameters" )
		else
			local arguments = {}
			local strStart = 1
			local splitStart, splitEnd = string.find( secondParm, ",", strStart, true )
			while splitStart do
				table.insert( arguments, string.sub( secondParm, strStart, splitStart-1) )
				strStart = splitEnd + 1
				splitStart, splitEnd = string.find( secondParm, ",", strStart, true )
			end
			table.insert( arguments, string.sub( secondParm, strStart ) )
			local k,w, listParms, listIndex = "", "", false, 0
			for i, v in ipairs( arguments ) do
				splitStart = string.find( v, "=", 1, true )
				if splitStart then
					k = string.sub( v, 1, splitStart-1 )
					w = string.sub( v, splitStart+1 )
				else
					k = v
					w = nil
				end
				if ( wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ][ k ] ~= nil ) then
					wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ][ k ]( w )
					listParms = true
				else
					printWDW( "Parameter ".. wdw_colour_MalachiteGreen.. k.. wdw_colour_Jasmine.. " unknown" )
				end
			end
			if ( listParms == true ) then
				wdwMod_Rotations[ wdw_currentSpec ][ WeDontWipeDB.rotation ][ "List" ]()
			end
		end

--------------------------------------------------------------------------------------------------------------------------------------------

	elseif ( firstParm3 == "ext" ) then
		printWDW( "Extra Commands Menu: ".. wdw_colour_MalachiteGreen.. "/wdw ...\n".. wdw_colour_Jasmine..
			wdw_colour_MalachiteGreen.. "ver".. wdw_colour_Jasmine.. " = Show the WDW version number\n"..
			wdw_colour_MalachiteGreen.. "gcd".. wdw_colour_Jasmine.. " = Show the current global cooldown (if possible)\n"..
			wdw_colour_MalachiteGreen.. "fre".. wdw_colour_Jasmine.. " = Show the update frequency for CA (tied to fps)\n"..
			wdw_colour_MalachiteGreen.. "day / night".. wdw_colour_Jasmine.. " = Toggle pre-WotLK day/night icon in the minimap\n"..
			wdw_colour_MalachiteGreen.. "sef / poth".. wdw_colour_Jasmine.. " = Hear the Elite Tauren Chieftains\n"..
			wdw_colour_MalachiteGreen.. "lam".. wdw_colour_Jasmine.. " = Hear the Lament of the Highborne" )

	elseif firstParm3 == "ver" then
		printWDW( "Version: ".. wdw_colour_MalachiteGreen.. tostring( GetAddOnMetadata( "WeDontWipe", "Version" ) ) )

	elseif firstParm3 == "gcd" then
		local start, duration = GetSpellCooldown( 61304 )
		if duration > 0 then
			wdw_GCDtop = duration
			if start > 0 then
				wdw_GCD = wdw_GCDtop - ( GetTime() - start )
			end
		else
			wdw_GCD = 0
		end
		printWDW( "GCD: ".. wdw_colour_MalachiteGreen.. wdw_GCDtop.. wdw_colour_Jasmine.. " with remaining: "..
			wdw_colour_MalachiteGreen.. round( wdw_GCD, 3 ).. wdw_colour_Jasmine.. "s. (To seed this, key in \"/wdw gcd\" "..
			"and hit Enter immediately after using an ability which triggers a GCD)" )

	elseif ( firstParm3 == "fre" ) or ( firstParm3 == "upd" ) then
		printWDW( "Update frequency: \124r".. ( round( 1 / GetFramerate(), 3) ).."\124cFF93CCEAs")

	elseif ( firstParm3 == "day" ) or ( firstParm3 == "nig" ) then
		if GameTimeTexture:IsVisible() then
			-- This to restore textures removed by the Day/Night AddOn (written by Helzondre)
			GameTimeFrame:SetNormalTexture( "Interface\\Calendar\\UI-Calendar-Button" )
			GameTimeFrame:SetPushedTexture( "Interface\\Calendar\\UI-Calendar-Button" )
			GameTimeTexture:Hide()
		else
			GameTimeTexture:Show()
		end

	elseif ( firstParm3 == "sef" ) or ( firstParm == "poth" ) then
		PlaySoundFile( "Sound\\Music\\ZoneMusic\\DMF_L70ETC01.mp3" )

	elseif ( firstParm3 == "lam" ) then
		PlaySoundFile("Sound\\Music\\GlueScreenMusic\\BCCredits_Lament_of_the_Highborne.mp3")
	end
end

SlashCmdList[ "WeDontWipe" ] = function( options ) Slash( options ) end

function WeDontWipe_ColourPickerPostClick( databaseEntity )
	if not ColorPickerFrame:IsVisible() then
		if databaseEntity  == "countdownColours" then
			Slash( "cnc ?" )
		elseif databaseEntity  == "swipeTextureColours" then
			Slash( "sto ?" )
		end
	end
end

--------------------------------------------------------------------------------------------------------------------------------------------

